unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, ADODB, comobj;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ADOConnection1: TADOConnection;
    Edit1: TEdit;
    Button2: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure changAccessDatabasePwd(oldpwd, newpwd, sFileName: string);    
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.changAccessDatabasePwd(oldpwd, newpwd, sFileName: string);
begin
  ADOConnection1.Provider := 'Microsoft.Jet.OLEDB.4.0';
  ADOConnection1.Properties.Item['Jet OLEDB:Database Password'].Value := oldpwd;
  ADOConnection1.Properties.Item['Data Source'].Value := sFileName;
  ADOConnection1.Mode := cmShareExclusive;
  if oldpwd = '' then oldpwd := '``';
  if newpwd = '' then newpwd := '``';
  ADOConnection1.Execute('ALTER Database Password ' + newpwd + ' ' + oldpwd);
  ShowMessage('password changed');
  ADOConnection1.Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Edit1.Text <> '' then
    changAccessDatabasePwd(Edit2.Text, Edit3.Text, Edit1.Text)
  else
    Button2Click(nil);
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenDialog1.InitialDir = '' then
    OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  if OpenDialog1.Execute then
    Edit1.Text := OpenDialog1.FileName;
end;

end.
